# To be included in curve creators
# Last edited on 1999-08-10 03:47:36 by hcgl

function trace_start(step, unit)
{
  trc_nsamples = 0;
  trc_step = step;
  trc_unit = unit;
  split("", trc_samples);
}

function trace_to(x,y,corner,  dx,dy,d,rest,step)
{
  if (trc_nsamples == 0)
    { trc_output(x,y);
      trc_x = x; trc_y = y;
      trc_travel = 0;
    }
  else
    { dx = x - trc_x; 
      dy = y - trc_y;
      d = sqrt(dx*dx + dy*dy);
      rest = d;
      while (trc_travel + rest > trc_step)
        { step = trc_step - trc_travel;
          trc_x = trc_x + (dx/d)*step;
          trc_y = trc_y + (dy/d)*step;
          trc_output(trc_x, trc_y);
          trc_travel = 0;
          rest = rest - step;
        }
      trc_travel += rest;
      trc_x = x; trc_y = y;
      if (corner && (trc_travel > 0))
        { trc_output(x,y);
          printf "( %.3f %.3f )\n", x, y > "/dev/stderr";
          trc_travel = 0;
        }
    }  
}

function trace_stop(   i)
{
  printf "samples = %d\n", trc_nsamples;
  printf "  samples = %d\n", trc_nsamples > "/dev/stderr";
  for (i=0; i<trc_nsamples; i++)
    { printf "%s\n", trc_samples[i]; }
}

function trc_output(x,y,  xi,yi)
{
  xi = int(x/trc_unit + 0.5);
  yi = int(y/trc_unit + 0.5);
  trc_samples[trc_nsamples] = sprintf(" %7d %7d 0", xi, yi);
  trc_nsamples ++;
}

function trc_error(msg)
{
  printf "! %s !\n", msg > "/dev/stderr";
  exit(1);
}
