INTERFACE PZMatrix;

(* 4x4 projective transformation matrices *)

IMPORT Rd, Wr, LR4x4;

TYPE
  T = LR4x4.T;

PROCEDURE Read(rd: Rd.T): T;
  (*
    Reads a transformation matrix from file "fname". *)
    
PROCEDURE Write(wr: Wr.T; READONLY m: T);
  (*
    Writes a 4x4 matrix to "wr". *)

END PZMatrix.
(*
  Copyright  2001 Universidade Estadual de Campinas (UNICAMP).
  Authors: Helena C. G. Leito and Jorge Stolfi.
  
  This file can be freely distributed, used, and modified, provided
  that this copyright and authorship notice is preserved, and that any
  modified versions are clearly marked as such.
  
  This software has NO WARRANTY of correctness or applicability for
  any purpose. Neither the authors nor their employers chall be held
  responsible for any losses or damages that may result from its use.
*)
