MODULE PZMatrix;
(* Last edited on 1999-02-22 02:18:08 by hcgl *)

IMPORT Rd, Wr, FileFmt, FGet, FPut, Thread;

CONST
  FileVersion = "97-01-21";
 
PROCEDURE Read(rd: Rd.T): T =
  VAR m: T;
  BEGIN
    FileFmt.ReadHeader(rd, "PZMatrix.T", FileVersion);
    EVAL FileFmt.ReadComment(rd, '|'); 
    FOR i := 0 TO 3 DO 
      FOR j := 0 TO 3 DO 
        FGet.Skip(rd);
        m[i,j] := FGet.LongReal(rd)
      END;
      FGet.EOL(rd);
    END;  
    FileFmt.ReadFooter(rd, "PZMatrix.T");
    RETURN m
  END Read;  
 

PROCEDURE Write(wr: Wr.T; READONLY m: T) =
  <* FATAL Wr.Failure, Thread.Alerted *>
  BEGIN 
    FileFmt.WriteHeader(wr, "PZMatrix.T", FileVersion);
    FOR i:= 0 TO  3 DO 
      FOR j:= 0 TO 3  DO 
         FPut.LongReal(wr,m[i,j]); 
         FPut.Space(wr, 2)
      END;
      Wr.PutText(wr, "\n")  
    END;
    FileFmt.WriteFooter(wr, "PZMatrix.T");
    Wr.Flush(wr)
  END Write;

BEGIN
END PZMatrix.
(*
  Copyright  2001 Universidade Estadual de Campinas (UNICAMP).
  Authors: Helena C. G. Leito and Jorge Stolfi.
  
  This file can be freely distributed, used, and modified, provided
  that this copyright and authorship notice is preserved, and that any
  modified versions are clearly marked as such.
  
  This software has NO WARRANTY of correctness or applicability for
  any purpose. Neither the authors nor their employers chall be held
  responsible for any losses or damages that may result from its use.
*)
