INTERFACE QPut;

(* "Fmt"-like procedures that write to a stream instead of returning TEXT. *)

IMPORT Wr, Fmt;
IMPORT Real AS R, LongReal AS LR;

CONST
  RMaxPrec = R.MaxSignifDigits-1;
  LRMaxPrec = LR.MaxSignifDigits-1;

PROCEDURE EOL(wr: Wr.T);
PROCEDURE Space(wr: Wr.T; count: CARDINAL := 1);

PROCEDURE Colon(wr: Wr.T);
  (*
    Equivalent to Wr.PutText(wr, ": ") *)
          
PROCEDURE Char(wr: Wr.T; x: CHAR);

PROCEDURE Bool(wr: Wr.T; x: BOOLEAN);

PROCEDURE Int(wr: Wr.T; x: INTEGER; pad: CARDINAL := 0);

PROCEDURE Real(
    wr: Wr.T; x: REAL; 
    prec: [1..RMaxPrec] := RMaxPrec; 
    style: Fmt.Style := Fmt.Style.Auto;
  );

PROCEDURE LongReal(
    wr: Wr.T; x: LONGREAL; 
    prec: [1..LRMaxPrec] := LRMaxPrec; 
    style: Fmt.Style := Fmt.Style.Auto;
  );

END QPut.
(*
  Copyright  2001 Universidade Estadual de Campinas (UNICAMP).
  Authors: Helena C. G. Leito and Jorge Stolfi.
  
  This file can be freely distributed, used, and modified, provided
  that this copyright and authorship notice is preserved, and that any
  modified versions are clearly marked as such.
  
  This software has NO WARRANTY of correctness or applicability for
  any purpose. Neither the authors nor their employers chall be held
  responsible for any losses or damages that may result from its use.
*)
